/*
       
        .
     .

.
            .
     ( ):
_		::= __ ENTER [{_  ENTER}]
__::= __ _
__	::= __
_	::= _JOIN | _RESTRICT
_JOIN		::= J _  
_RESTRICT 	::= S _ _  
_		::= __
_::= > | < | =
				::= __
			::= __ | #_
__	::= __
_	::= __
 :
1. _		    0  ATTRIBUTES_IN_RELATION-1 .
2. _		    0  RELATIONS_IN_DATABASE-1 .
3. __	    0  ___-1 .
     :
	   [0 JOIN(=3)]
	  /					  \
	[1 JOIN(=1)]	  [2 RESTRICT(=2, =">", =19)]
	/				  \											   |
=2	[3 RESTRICT(=1, ="<", =31)]   =1
					|
				=3
  :
0 J 3 1 2
1 J 1 #2 3
2 S 2 > 19 #1
3 S 1 < 31 #3

.
        :
::=_;
_	::= _JOIN | _RESTRICT
_JOIN		::= JOIN(_, , )
_RESTRICT 	::= RESTRICT(_, _, , )
_		::= __
_::= > | < | = | >= | <= | <>
				::= __
			::= _
@memo  
@name  Compiler_Implementation
@author .. , .. 
@version 1.0
@see Database DatabaseConfig Compiler
*/


#include "compiler.h"	// 
#include "globals.h"	//   
#include "dbmgr.h"
#include "omegacfg.h"
#include "dbparams.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>


static void MakeQueryTree(char *);					/*    */
static int CalculateAry(treenode_t *);				/*   "" */
static treenode_t * treedup(treenode_t *);

/*@{*/


/*
    
@name Compiler_Implementation_Types
@memo   
@see Compiler_Functions Compiler_Constants
*/

/*@{*/

/*
@memo    
*/
typedef treenode_t * queryarray_t;

/*@}*/

/*
    
@name Compiler_Implementation_Types
@memo   
@see Compiler_Functions Compiler_Constants
*/

/*@{*/

/*
@memo    
*/
static queryarray_t QUERYARRAY;


/*
@memo  
*/
static treenode_t * QUERYTREE;

/*
@memo   
*/
static int initflag=FALSE;

/*@}*/


/*
    
@name Compiler_Implementation_Functions
@memo   
@see Compiler_Types Compiler_Constants
*/

/*@{*/

/*
       
         .
       .
@memo   
@see cp_CompileQuery
*/
void cp_InitCompiler()
{
	if (initflag)
		return;
	initflag=TRUE;   
}


/*
          
      .
       ""     .
@memo  
@param query     (    -  )
@return          NULL   
@see QUERY_FNAME
*/
treenode_t * cp_CompileQuery(char * query)
{
	assert(initflag==TRUE);
	MakeQueryTree(query);
	CalculateAry(QUERYTREE);
	return QUERYTREE;
}


/*
@memo   
*/
static void MakeQueryTree(char * query)
{
	FILE * f;
	char c;
	int i, nodeqty, noleaves, leafqty, attr, r1, r2, literal;

	assert(initflag==TRUE);

	nodeqty=(1<<(QUERY_TREE_LEVEL_MAX+1))-1;	/*   ,   -   SCAN */
	noleaves=(1<<QUERY_TREE_LEVEL_MAX)-1;		/*  ,    -   SCAN */

/*	printf("%ld Kbytes needed\n", (nodeqty*sizeof(treenode_t))/1024); */

	QUERYARRAY=(treenode_t *) calloc(nodeqty, sizeof(treenode_t));
	assert(QUERYARRAY!=NULL);
	for (i=0; i<nodeqty; i++) {
		QUERYARRAY[i].fragmentattr=NIL;
		QUERYARRAY[i].cargo=NULL;	
		QUERYARRAY[i].fragmentfn=NULL;
		QUERYARRAY[i].ary=NIL;
		QUERYARRAY[i].nextfn=NULL;
		QUERYARRAY[i].resetfn=NULL;
		QUERYARRAY[i].isBOF=QUERYARRAY[i].isEOF=NIL;
		QUERYARRAY[i].left=QUERYARRAY[i].right=NULL;
	}

	leafqty=0;
	f=fopen(query, "rt");
	assert(f!=NULL);
	while (!feof(f)) {
		fscanf(f, "%d %c %d ", &i, &c, &attr);
		if (c=='j' || c=='J') {
			QUERYARRAY[i].rel_operation=JOIN;
			QUERYARRAY[i].cargo=(JOIN_cargo_t *) calloc(1, sizeof(JOIN_cargo_t));
			assert(QUERYARRAY[i].cargo!=NULL);
			((JOIN_cargo_t *) QUERYARRAY[i].cargo)->attribute=attr;

			fscanf(f, "%c", &c);
			if (c=='#') {
				fscanf(f, "%d", &r1);
				QUERYARRAY[noleaves+leafqty].rel_operation=SCAN;
				QUERYARRAY[noleaves+leafqty].cargo=(SCAN_cargo_t *) calloc(1, sizeof(SCAN_cargo_t));
				assert(QUERYARRAY[noleaves+leafqty].cargo!=NULL);
				((SCAN_cargo_t *) QUERYARRAY[noleaves+leafqty].cargo)->relation=r1;
				QUERYARRAY[noleaves+leafqty].left=QUERYARRAY[noleaves+leafqty].right=NULL;
				QUERYARRAY[i].left=&QUERYARRAY[noleaves+leafqty];
				leafqty++;
			} else
				QUERYARRAY[i].left=&QUERYARRAY[c-'0'];
			fscanf(f, " %c", &c);
			if (c=='#') {
				fscanf(f, "%d", &r2);
				QUERYARRAY[noleaves+leafqty].rel_operation=SCAN;
				QUERYARRAY[noleaves+leafqty].cargo=(SCAN_cargo_t *) calloc(1, sizeof(SCAN_cargo_t));
				assert(QUERYARRAY[noleaves+leafqty].cargo!=NULL);
				((SCAN_cargo_t *) QUERYARRAY[noleaves+leafqty].cargo)->relation=r2;
				QUERYARRAY[noleaves+leafqty].left=QUERYARRAY[noleaves+leafqty].right=NULL;
				QUERYARRAY[i].right=&QUERYARRAY[noleaves+leafqty];
				leafqty++;
			} else
				QUERYARRAY[i].right=&QUERYARRAY[c-'0'];
		} else
			if (c=='r' || c=='R') {
				QUERYARRAY[i].rel_operation=RESTRICT;
				QUERYARRAY[i].cargo=(RESTRICT_cargo_t *) calloc(1, sizeof(RESTRICT_cargo_t));
				assert(QUERYARRAY[i].cargo!=NULL);
				QUERYARRAY[i].right=NULL;
				((RESTRICT_cargo_t *) QUERYARRAY[i].cargo)->attribute=attr;
				fscanf(f, "%c %d ", &c, &literal);
				switch (c) {
				case '>': ((RESTRICT_cargo_t *) QUERYARRAY[i].cargo)->theta=GREATER; break;
				case '<': ((RESTRICT_cargo_t *) QUERYARRAY[i].cargo)->theta=LESS; break;
				case '=': ((RESTRICT_cargo_t *) QUERYARRAY[i].cargo)->theta=EQUAL; break;
				default : assert(0);
				}
				((RESTRICT_cargo_t *) QUERYARRAY[i].cargo)->literal=literal;
				fscanf(f, " %c", &c);
				if (c=='#') {
					fscanf(f, "%d", &r1);
					QUERYARRAY[noleaves+leafqty].rel_operation=SCAN;
					QUERYARRAY[noleaves+leafqty].cargo=(SCAN_cargo_t *) calloc(1, sizeof(SCAN_cargo_t));
					assert(QUERYARRAY[noleaves+leafqty].cargo!=NULL);
					((SCAN_cargo_t *) QUERYARRAY[noleaves+leafqty].cargo)->relation=r1;
					QUERYARRAY[noleaves+leafqty].left=QUERYARRAY[noleaves+leafqty].right=NULL;
					QUERYARRAY[i].left=&QUERYARRAY[noleaves+leafqty];
					leafqty++;
				} else
					QUERYARRAY[i].left=&QUERYARRAY[c-'0'];
			} else
				assert(0);
		fscanf(f, "\n");
	}

	QUERYTREE=treedup(&QUERYARRAY[0]);
}


/*
@memo   ""
*/
static int CalculateAry(treenode_t * root)
{
	int left_ary, right_ary;

	assert(initflag==TRUE);

	if (root==NULL) 
		return 0;

	switch (root->rel_operation) {
	case SCAN:		
		assert(SCAN_CARGO(root, relation)>=0 && SCAN_CARGO(root, relation)<RELATIONS_IN_DATABASE);
		root->ary=DICTIONARY.relations[SCAN_CARGO(root, relation)].ary;
		assert(root->ary==ATTRIBUTES_IN_RELATION);
		break;
	case RESTRICT:
		root->ary=CalculateAry(root->left);
		break;
	case JOIN:
		left_ary=CalculateAry(root->left);
		right_ary=CalculateAry(root->right);
		root->ary=left_ary+right_ary-1;
		break;
	default:
		assert(0);
	}
	assert(root->ary>0 && root->ary<=ATTRIBUTES_IN_RELATION_MAX);
	return root->ary;
}


static treenode_t * treedup(treenode_t * t1)
{
	treenode_t * t2;

	if (t1==NULL)
		return NULL;
	t2=(treenode_t *) calloc(1, sizeof(treenode_t));
	assert(t2!=NULL);
	t2->ary=t1->ary;
	t2->nextfn=t1->nextfn;
	t2->fragmentattr=t1->fragmentattr;
	t2->fragmentfn=t1->fragmentfn;
	t2->resetfn=t1->resetfn;
	t2->rel_operation=t1->rel_operation;
	switch (t2->rel_operation) {
	case JOIN:
		t2->cargo=(JOIN_cargo_t *) calloc(1, sizeof(JOIN_cargo_t));
		assert(t2->cargo!=NULL);
		JOIN_CARGO(t2, attribute)=JOIN_CARGO(t1, attribute);
		break;
	case RESTRICT:
		t2->cargo=(RESTRICT_cargo_t *) calloc(1, sizeof(RESTRICT_cargo_t));
		assert(t2->cargo!=NULL);
		RESTRICT_CARGO(t2, attribute)=RESTRICT_CARGO(t1, attribute);
		RESTRICT_CARGO(t2, theta)=RESTRICT_CARGO(t1, theta);
		RESTRICT_CARGO(t2, literal)=RESTRICT_CARGO(t1, literal);
		break;
	case SCAN:
		t2->cargo=(SCAN_cargo_t *) calloc(1, sizeof(SCAN_cargo_t));
		assert(t2->cargo!=NULL);
		SCAN_CARGO(t2, relation)=SCAN_CARGO(t1, relation);
		break;
	default:
		assert(0);
	}
	t2->left=treedup(t1->left);
	t2->right=treedup(t1->right);
	return t2;
}
