/*
  JOIN ( )  , 
       .
.. , .. 
@version 1.0
*/

#include "jmainmem.h"	// 
#include "bracket.h"	//  
#include "dbmgr.h"
#include <string.h>
#include <stdlib.h> 
#include <stdio.h>
#include <assert.h>

/*
  JOIN  
@param node     
@return        , 
  ;     --   -EOF.
*/
static tupleptr_t NextJOIN_MainMemory(treenode_t * node);

/*
@memo    JOIN  
@param node     
*/
static void ResetJOIN_MainMemory(treenode_t * node);

/**
  JOIN_MAINMEMORY (   , 
       )   :

\begin{tabular}{lll}
{\bf N /}	& {\bf }							& {\bf }	\\
1			& int attribute							&   \\
2			& domain_t * buffer[\Ref{BUFLEN_MAX}]	&     \\
3			& int isalloc							&  " " (     ) \\
4			& long current							&      \\
5			& long buflen;							&     (   \Ref{JOIN_MAINMEMORY_BUFLEN_MAX})
\end{tabular}
@memo   JOIN_MAINMEMORY
@see JOIN_MAINMEMORY_BUFLEN_MAX
*/
typedef struct {
	tuple_t buffer[JOIN_MAINMEMORY_BUFLEN_MAX];	//    
	int isalloc;					//  "   "
	long current;					//     
	long buflen;					//    
} JOIN_MAINMEMORY_cargo_t;

#define JOIN_MAINMEMORY_CARGO(treenode, attr)	((JOIN_MAINMEMORY_cargo_t *) JOIN_CARGO(treenode, supercargo))->attr

/**
       
   JOIN_MAINMEMORY 
(  ,       
   ). 
@memo   JOIN_MAINMEMORY
@param node   
@param isleft  " ( )    "
*/
void AssignJOIN_MainMemory(treenode_t * node, int isleft)
{
	treenode_t * Join_MainMemory=node;
	int attr;

	assert(node!=NULL);
	assert(node->rel_operation==JOIN);
	attr=JOIN_CARGO(node, attribute);
	assert(isleft==FALSE); /* FIXME!      ,   
							  .
							*/

	node->phys_operation=JOIN_MAINMEMORY;
	node->nextfn=(next_fn_t) NextJOIN_MainMemory;
	node->resetfn=(reset_fn_t) ResetJOIN_MainMemory;
	JOIN_CARGO(node, supercargo)=(JOIN_MAINMEMORY_cargo_t *) calloc(1, sizeof(JOIN_MAINMEMORY_cargo_t));
	assert(JOIN_CARGO(node, supercargo)!=NULL);
	JOIN_MAINMEMORY_CARGO(node, isalloc)=FALSE;
}

/*
@memo    JOIN  
@param node     
*/
static void ResetJOIN_MainMemory(treenode_t * node)
{
	assert(node!=NULL);
}

/*
  JOIN  
@param node     
@return        , 
  ;     --   -EOF.
*/
static tupleptr_t NextJOIN_MainMemory(treenode_t * node)
{
//    
#define RESCPY(node, tuple)	memcpy(node->result, tuple, node->ary*sizeof(domain_t))
#define L	node->left->result
#define R	JOIN_MAINMEMORY_CARGO(node, buffer)[JOIN_MAINMEMORY_CARGO(node, current)]

	long i;

	assert(node!=NULL);

//      
	if (!JOIN_MAINMEMORY_CARGO(node, isalloc)) {
		JOIN_MAINMEMORY_CARGO(node, isalloc)=TRUE;
		JOIN_MAINMEMORY_CARGO(node, current)=0;
		while (!IsEOF(br_Next(node->right))) {
			assert(JOIN_MAINMEMORY_CARGO(node, current)<JOIN_MAINMEMORY_BUFLEN_MAX);
			memcpy(JOIN_MAINMEMORY_CARGO(node, buffer[JOIN_MAINMEMORY_CARGO(node, current)]), node->right->result, node->ary*sizeof(domain_t));
			JOIN_MAINMEMORY_CARGO(node, current)++;
		}
		JOIN_MAINMEMORY_CARGO(node, buflen)=JOIN_MAINMEMORY_CARGO(node, current);
		assert(JOIN_MAINMEMORY_CARGO(node, buflen)>0);
//      (  0)		
		JOIN_MAINMEMORY_CARGO(node, current)=-1; 
	}

//    
	if (node->left->isBOF) 
		br_Next(node->left);
//    ?
	if (node->left->isEOF) {
		RESCPY(node, EOFtuple);
		return node->result;
	}

//     
	do {
		JOIN_MAINMEMORY_CARGO(node, current)++;
		if (JOIN_MAINMEMORY_CARGO(node, current)==JOIN_MAINMEMORY_CARGO(node, buflen)) {
			JOIN_MAINMEMORY_CARGO(node, current)=0;
			br_Next(node->left);
			if (node->left->isEOF) {
				RESCPY(node, EOFtuple);
				return node->result;
			}
		}
	} while (L[JOIN_CARGO(node, attribute)]!=R[JOIN_CARGO(node, attribute)]);

//    
	for (i=0; i<node->left->ary; i++)
		node->result[i]=L[i];
	for (i=0; i<JOIN_CARGO(node, attribute); i++)
		node->result[node->left->ary+i]=R[i];
	for (i=JOIN_CARGO(node, attribute)+1; i<node->right->ary; i++)
		node->result[node->left->ary+i-1]=R[i];

	return node->result;

#undef RESCPY
#undef L
#undef R
}