/*
      
          .
     .
@memo  
@name  Parallelizer_Implementation
@author (c) 2004 .. , .. 
@version 1.0
@see Compiler Database
*/

#include "parallel.h"	//  
#include "exchange.h"	//   EXCHANGE
#include "globals.h"	//   
#include "bracket.h"	//   
#include "dbmgr.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

static void InsertEXCHANGE(treenode_t *); /*   EXCHANGE */

/*
@memo   
*/
static int initflag=FALSE;

/*
  EXCHANGE,      .
        EXCHANGE.
@memo  ""
*/
static int exchgcnt;

/*
       
         .
       .
@memo   
@see pl_ParallelizeQuery
*/
void pl_InitParallelizer()
{
	if (initflag)
		return;
	initflag=TRUE;
	exchgcnt=1; /*   !! */
}

/*
        
    .     EXCHANGE 
" "    .   0   
 EXCHANGE,     .
@memo  
@param root        
@return SUCCESS       
@see treenode_t AgentManager am_MakeAgent
*/
void pl_ParallelizeQuery(treenode_t * root)
{
	assert(initflag==TRUE);
	assert(root!=NULL);
	InsertEXCHANGE(root);
}

/*
        
    .
@memo  
@param root        
*/
static void InsertEXCHANGE(treenode_t * root)
{
	treenode_t *lnode=NULL, *rnode=NULL;

	if (root==NULL) 
		return;

	switch (root->rel_operation) {
	case SCAN: 
		root->fragmentattr=DICTIONARY.relations[SCAN_CARGO(root, relation)].fragmentattr;
		root->fragmentfn=DICTIONARY.relations[SCAN_CARGO(root, relation)].fragmentfn;
		break;

	case RESTRICT:
		if (root->left->fragmentattr==NIL)
			InsertEXCHANGE(root->left);
		root->fragmentattr=root->left->fragmentattr;
		root->fragmentfn=root->left->fragmentfn;
		break;

	case JOIN:
		assert(root->left!=NULL);
		assert(root->right!=NULL);
		root->fragmentattr=JOIN_CARGO(root, attribute);
	
		if (root->left->fragmentattr==NIL)  //      --  . 
			InsertEXCHANGE(root->left);
		if (root->right->fragmentattr==NIL)	//      --  . 
			InsertEXCHANGE(root->right);
//      , 
//            
			if (root->left->fragmentfn!=root->right->fragmentfn)
				root->fragmentfn=db_FragmentByDefault;
			else
//            
				root->fragmentfn=root->left->fragmentfn;			

//    !=    ,   EXCHANGE  . 
		if (JOIN_CARGO(root, attribute)!=root->left->fragmentattr) {
			lnode=MakeEXCHANGE(exchgcnt++, root->fragmentfn, root->left->ary, 
				root->fragmentattr, root->fragmentfn);
			assert(lnode!=NULL);
			lnode->right->left=root->left;
			root->left=lnode;
		}

//    !=    ,   EXCHANGE  . 
		if (JOIN_CARGO(root, attribute)!=root->right->fragmentattr) {
			rnode=MakeEXCHANGE(exchgcnt++, root->fragmentfn, root->right->ary, 
				root->fragmentattr, root->fragmentfn);
			assert(rnode!=NULL);
			rnode->right->left=root->right;
			root->right=rnode;
		}
		break;

	default:
		assert(0);
	}
}

