/*
   RESTRICT ( )
.. , .. 
*/

#include "restrict.h"	//  
#include "bracket.h"	//   
#include "dbmgr.h"
#include <stdlib.h>
#include <string.h>
#include <assert.h>

// 

/*
@memo   RESTRICT
@param node     
@return        , 
  ;     --   -EOF.
*/
static tupleptr_t NextRESTRICT(treenode_t * node);

/*
@memo   RESTRICT
@param node     
*/
static void ResetRESTRICT(treenode_t * node);

// 

/**
    EXCHANGE-     .
@memo    RESTRICT
@param   
@see AssignSCAN AssignSTORE MakeEXCHANGE
*/
void AssignRESTRICT(treenode_t * node)
{
	assert(node!=NULL);
	assert(node->rel_operation==RESTRICT);
	assert(node->cargo!=NULL);

	node->phys_operation=RESTRICT;
	node->nextfn=(next_fn_t) NextRESTRICT;
	node->resetfn=(reset_fn_t) ResetRESTRICT;
}

/*
@memo     
@param node    
@param tuple   
*/
#define RESCPY(node, tuple)	memcpy(node->result, tuple, node->ary*sizeof(domain_t))

/*
  RESTRICT
@param node     
@return        , 
  ;     --   -EOF.
*/
static tupleptr_t NextRESTRICT(treenode_t * node)
{
	tupleptr_t t;

	assert(node!=NULL);

	while (!node->left->isEOF) {
		t=br_Next(node->left);
		switch (RESTRICT_CARGO(node, theta)) {
		case EQUAL: 
			if (t[RESTRICT_CARGO(node, attribute)]==RESTRICT_CARGO(node, literal)) {
				RESCPY(node, t);
				return node->result;
			}
			break;
		case NOT_EQUAL:
			if (t[RESTRICT_CARGO(node, attribute)]!=RESTRICT_CARGO(node, literal)) {
				RESCPY(node, t);
				return node->result;
			}
			break;
		case GREATER:
			if (t[RESTRICT_CARGO(node, attribute)]>RESTRICT_CARGO(node, literal)) {
				RESCPY(node, t);
				return node->result;
			}
			break;
		case LESS:
			if (t[RESTRICT_CARGO(node, attribute)]<RESTRICT_CARGO(node, literal)) {
				RESCPY(node, t);
				return node->result;
			}
			break;
		case GREATER_OR_EQUAL:
			if (t[RESTRICT_CARGO(node, attribute)]>=RESTRICT_CARGO(node, literal)) {
				RESCPY(node, t);
				return node->result;
			}
			break;
		case LESS_OR_EQUAL:
			if (t[RESTRICT_CARGO(node, attribute)]<=RESTRICT_CARGO(node, literal)) {
				RESCPY(node, t);
				return node->result;
			}
			break;
		default:
			assert(0);
		}
	}
	RESCPY(node, EOFtuple);
	return node->result;
}

/*
  RESTRICT
*/
static void ResetRESTRICT(treenode_t * node)
{
	assert(node!=NULL);
	return;
}





