/**
  SORT (  ). 
@author (c) 2004 .. 
@version 2.0
*/

#include "sort.h"		//  
#include "exchange.h"	//  EXCHANGE
#include "bracket.h"	//   
#include "omegacfg.h"	//   
#include "dbmgr.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <assert.h>

/* -------------   -----------------
 *         .
 *      - ResetSORT.  
 *   NextSORT       
 *   ,     NULL.
 * 
 *         ,   
 * Reset  Next     ResetSORT  NextSORT.   
 * ,        SuperCargo.
 *       (     ).
 *   SuperCargo     WhoAmi -   .
 * 
 *       Descriptor  attr:
 * Descriptor    supercargo      .
 * attr      (    SORT).
 *
 *   ,    .      
 * ,  ,      
 *       .
 *
 *          ,   NextSORT
 *      ,   .
 *            
 * .
 *
 *       : SIZEMEM.
 * SIZEMEM     ,     
 *      .
 *
 *          Descriptor, attr, 
 *       .
 */

/* ----------------     --------------
 * ResetSORT            .
 * NextSORT  ,        .    
 * ,        ( NULL)
 *
 *     
 * 
 * FILENAME_LEN_MAX, PATHNAME_LEN_MAX
 */

/* INTERFACE */

/* Types: */

typedef struct {
	char Filename[FILENAME_LEN_MAX + PATHNAME_LEN_MAX];
} ListFiles_t;

typedef struct {
	tuple_t buffer[SORT_BUFLEN_MAX];
	long size;
} TupleBuffer_t;

/*
 *   SORT (  )   :
 * Purphandle -  ,    ,    .
 * WhoAmi -     .
 * tuplebuffer -    .
 * listfiles -     .
 * ListSize -    .
 * ResetSign -     NextSORT().
*/
typedef struct {
	FILE *Purphandle;
	int WhoAmi;
	TupleBuffer_t tuplebuffer;
	ListFiles_t listfiles[SORT_TEMPFILES_MAX];
	long ListSize;
	int ResetSign;
} SORT_MERGE_cargo_t;

#define SORT_MERGE_CARGO(treenode, attr)	((SORT_MERGE_cargo_t *) SORT_CARGO(treenode, supercargo))->attr

/* Variables:*/

/* .     (   )    */
long Counter;

/* Definitions: */

#define RESCPY(node, tuple)	memcpy(node->result, tuple, node->ary*sizeof(domain_t))
/*    tuple_t src  tuple_t dest */
#define TUPLECPY(dest, src, ary) memcpy(dest, src, ary*sizeof(domain_t))
/* 
 *  ary   src  dest
 *         .
*/
#define BYTECPY(dest, src, ary) memcpy(dest, src, ary)

/* Function prototypes :*/

treenode_t * MakeSORT(int ary, int attribute, int fragmentattr, fragment_fn_t fragmentfn);
static tupleptr_t NextSORT(treenode_t * node);
static void ResetSORT(treenode_t * node);
void AssignSORT_Merge(treenode_t * node);
int jm_gettuple(FILE *handle, tupleptr_t tuple, int ary);
char * CreateFilename(int WhoAmi, char *Filename);
void savetofile_buffer(char *Filename, SORT_MERGE_cargo_t *Descriptor, long buffersize, int ary);
void sort(TupleBuffer_t *tuplebuffer, int ary, int attr, long p, long r);
int jm_gettuple(FILE *handle, tupleptr_t tuple, int ary);
int jm_puttuple(FILE *handle, tupleptr_t tuple, int ary);

/* IMPLEMENTATION */

void AssignSORT_Merge(treenode_t *node)
{
	assert(node!=NULL);
	
	node->phys_operation=SORT;
	node->nextfn=(next_fn_t) NextSORT;
	node->resetfn=(reset_fn_t) ResetSORT;
	return;
} /* AssignSORT() */

treenode_t * MakeSORT(int ary, int attribute, int fragmentattr, fragment_fn_t fragmentfn)
{
	treenode_t * Sort = NULL;

	Sort = (treenode_t *) calloc(1, sizeof(treenode_t));
	assert(Sort != NULL);
	Sort->ary = ary;
	Sort->fragmentattr = fragmentattr;
	Sort->fragmentfn = fragmentfn;
	Sort->left = NULL;
	Sort->right = NULL;
	Sort->cargo = (SORT_cargo_t *) calloc(1, sizeof(SORT_cargo_t));
	SORT_CARGO(Sort, attribute) = attribute;
	SORT_CARGO(Sort, supercargo) = (SORT_MERGE_cargo_t *) calloc(1, sizeof(SORT_MERGE_cargo_t));
	SORT_MERGE_CARGO(Sort, WhoAmi) = WHOAMI;

	Sort->rel_operation = NIL;
	Sort->phys_operation = SORT;

	SORT_MERGE_CARGO(Sort, ResetSign) = TRUE;

	return Sort;
} /* MakeSORT() */

/*
 *     .
 *   :
 *   =   = "N" +    + "C" +   Counter +".tmp"
*/
char * jm_CreateFilename(int WhoAmi, char *Filename)
{
	char sn[12] = "";

	Counter++;
	BYTECPY(Filename, PATH_TO_RELATIONS, strlen(PATH_TO_RELATIONS)+1);
	sprintf(sn, "%s", "N");
	strcat(Filename, sn);
	sprintf(sn, "%d", WhoAmi);
	strcat(Filename, sn);
	sprintf(sn, "%s", "C");
	strcat(Filename, sn);
	sprintf(sn, "%ld", Counter);
	strcat(Filename,sn);
	strcat(Filename, ".tmp");
	return Filename;
} /* CreateFilename() */

/*
 *   Descriptor->tuplebuffer,  buffersize,  ary   Filename.
 *     Filename -  ,      .
*/
void savetofile_buffer(char *Filename, SORT_MERGE_cargo_t *Descriptor, long buffersize, int ary)
{
	FILE *Filehandle;
	long count = 0;
	int res;

	jm_CreateFilename(Descriptor->WhoAmi,Filename);
	Filehandle = fopen(Filename,"wt");
	assert(Filehandle != NULL);
	
	while (count < buffersize) {
		res = jm_puttuple(Filehandle, Descriptor->tuplebuffer.buffer[count], ary);
		assert(res != EOF);
		count++;
	}

	res = fclose(Filehandle);
	assert(res != EOF);
	return;
} /* savetofile_buffer() */

/*
 * @memo      .
*/
long partition(TupleBuffer_t *tuplebuffer, int ary, int attr, long p, long r)

{
	domain_t x;
	tuple_t temp;
	long i = p - 1;
	long j = r + 1;
	long k = rand()%(r-p) + p;
	
	TUPLECPY(temp, tuplebuffer->buffer[k], ary);
	TUPLECPY(tuplebuffer->buffer[k],  tuplebuffer->buffer[p], ary);
	TUPLECPY(tuplebuffer->buffer[p], temp, ary); 
	x = tuplebuffer->buffer[p][attr];

	while (1==1) {
		do
			j--;
		while ((tuplebuffer->buffer[j][attr] >= x) && (j>p));

		do
			i++;
		while ((tuplebuffer->buffer[i][attr] < x) && (i<r));

			if (i<j) {
				TUPLECPY(temp, tuplebuffer->buffer[i], ary); // temp = jm_gettuple(i, ary, tuplebuffer);
				TUPLECPY(tuplebuffer->buffer[i], tuplebuffer->buffer[j], ary); //insert_buffer(jm_gettuple(j, ary, tuplebuffer), i, ary,tuplebuffer);
				TUPLECPY(tuplebuffer->buffer[j], temp, ary); //insert_buffer(temp, j, ary, tuplebuffer);
			}
			else
				return j;
	}
}

/*
 * @memo  "" .
*/

void quicksort(TupleBuffer_t *tuplebuffer, int ary, int attr, long p, long r)
{
	long q;
	if (p < r) {
		q = partition (tuplebuffer, ary, attr, p, r);
		quicksort (tuplebuffer, ary, attr, p, q);
		quicksort (tuplebuffer, ary, attr, q+1, r);
	}
	return;
}

/* 
 * @memo  "" .
*/
void sort(TupleBuffer_t *tuplebuffer, int ary, int attr, long p, long r) {

	quicksort (tuplebuffer, ary, attr, p, r);

	return;
} /* sort() */

/*
 *   .
 *      :
 *      (   )
 * .
 *   .
 *    ,   .
*/
void step1(treenode_t *node, SORT_MERGE_cargo_t *Descriptor, int attr)
{
	long count;
	long countfiles = 0;

	assert (node != NULL);
	br_Next(node->left);
	if (node->left->isEOF) {
		Descriptor->ListSize = 0;
		return;
	}
	
	Descriptor->tuplebuffer.size = SORT_BUFLEN_MAX;
	count = 0;	

	while (TRUE) {

		if ((Descriptor->tuplebuffer.size == count) || (node->left->isEOF)) 
		{ /*    */
			sort(&Descriptor->tuplebuffer, node->left->ary, attr, 0, count-1);
			savetofile_buffer(Descriptor->listfiles[countfiles].Filename, Descriptor, count, node->left->ary);
			count = 0;
			countfiles++;
			assert(countfiles < SORT_TEMPFILES_MAX);
			if (node->left->isEOF) 
			{
				Descriptor->ListSize = countfiles;

				return;
			}
		}

		TUPLECPY(Descriptor->tuplebuffer.buffer[count], node->left->result, node->left->ary);		
		count++;
		assert(count <= SORT_BUFLEN_MAX);

		br_Next(node->left);

	} /*    */
	
} /* step1() */

/*
 *   tuple,  ary  ( )    handle.
 *        .
 *    ,  EOF.
*/
int jm_gettuple(FILE *handle, tupleptr_t tuple, int ary)
{
	int res, i;

	for (i=0; i<ary; i++) {
		res = fscanf(handle, "%ld\t", &tuple[i]);
	}
	res = fscanf(handle, "\n");

	return res;
}

/*
 *   tuple,  ary  ( )    handle.
 *        .
 *     EOF.
*/
int jm_puttuple(FILE *handle, tupleptr_t tuple, int ary)
{
	int res, i;

	for (i=0; i<ary; i++) {
		res = fprintf(handle, "%ld\t", tuple[i]);
	}
	res = fprintf(handle, "\n");

	return res;
}

/*
 *  ()   .
 *      (  attr)  (  Descriptor->listfiles[])  . 
 *        ,    .
 *     ,      .
*/
void step2(treenode_t *node, SORT_MERGE_cargo_t *Descriptor, int attr)
{

	FILE *Filehandle1, *Filehandle2, *handle;
	char Filename[FILENAME_LEN_MAX + PATHNAME_LEN_MAX];
	tuple_t Data1, Data2;
	long n = 0;
	int res;

	if (Descriptor->ListSize < 2)
	/*     ,     . */
		return;

	while (2*n + 1 < Descriptor->ListSize) 
	{
/*
 *    listfiles      .
 * ,      ,   2n  2n+1       n.
*/
		Filehandle1 = fopen(Descriptor->listfiles[2*n].Filename ,"rt");
		assert(Filehandle1 != NULL);
		Filehandle2 = fopen(Descriptor->listfiles[2*n+1].Filename ,"rt");
		assert(Filehandle2 != NULL);

		res = jm_gettuple(Filehandle1, Data1, node->ary);
		assert(res != EOF);
	
		res = jm_gettuple(Filehandle2, Data2, node->ary);

		jm_CreateFilename(Descriptor->WhoAmi,Filename);
		handle = fopen(Filename ,"wt");
		assert(handle != NULL);

		while ((Data1[attr] != NIL) || (Data2[attr] != NIL)) 
			//        ...
		{
			if (((Data1[attr] == NIL) || (Data2[attr] <= Data1 [attr])) && (Data2[attr] != NIL))
//      2      1,      .
			{
				res = jm_puttuple(handle, Data2, node->ary);
				assert(res != EOF);
				if (!feof(Filehandle2))
					jm_gettuple(Filehandle2, Data2, node->ary);
				else
					Data2[attr] = NIL;
			}
			else
			if (((Data2[attr] == NIL) || (Data2[attr] >= Data1 [attr])) && (Data1[attr] != NIL))
//      1      2,      .
			{
				res = jm_puttuple(handle, Data1, node->ary);
				assert(res != EOF);
				
				if (!feof(Filehandle1)) 
					jm_gettuple(Filehandle1, Data1, node->ary);
				else
					Data1[attr] = NIL;
			}

		}
		res = fclose(Filehandle1);
		assert(res != EOF);
		res = fclose(Filehandle2);
		assert(res != EOF);
		res = remove(Descriptor->listfiles[2*n].Filename);
		assert(res != -1);
		res = remove(Descriptor->listfiles[2*n+1].Filename);
		assert(res != -1);
		res = fclose(handle);
		assert(res != EOF);
		BYTECPY (Descriptor->listfiles[n].Filename, Filename, strlen(Filename)+1);
		
		
		n++;
		/* 
		 *   .
		 *  ,     ,          .
		*/
		if ((2*n + 1 >= Descriptor->ListSize) ) {
			if (2*n + 1 == Descriptor->ListSize) {
				BYTECPY (Descriptor->listfiles[n].Filename, Descriptor->listfiles[2*n].Filename, strlen(Descriptor->listfiles[2*n].Filename)+1);
				n++;
			}
			Descriptor->ListSize = n;
			n = 0;
		}
	}

	return;
} /* step2() */

/*
  SORT
@param node     
*/
static void ResetSORT(treenode_t * node)
{
	assert(node!=NULL);
	
	return;
}

/*
 *     ,  EOF,   .
*/
static tupleptr_t NextSORT(treenode_t * node)
{
	tuple_t result;

	SORT_MERGE_cargo_t *Descriptor;
	long attr;
	int res;
	
	assert(node != NULL);
	Descriptor = (SORT_MERGE_cargo_t *) SORT_CARGO(node, supercargo);
	assert(Descriptor != NULL);
	attr = SORT_CARGO(node, attribute);

	if (Descriptor->ResetSign) {
		/*        ,     */
		Descriptor->ResetSign = FALSE;
		step1(node, Descriptor, attr);
		step2(node, Descriptor, attr);
		Descriptor->Purphandle = fopen(Descriptor->listfiles[0].Filename, "rt");
		assert(Descriptor->Purphandle != NULL);
	}

	if (feof(Descriptor->Purphandle)) 
	{
		/*   . */
		TUPLECPY(result, EOFtuple, node->ary);
		res = fclose(Descriptor->Purphandle);
		assert(res != EOF);
		res = remove(Descriptor->listfiles[0].Filename);
		assert(res != -1);
	}
	else 
		jm_gettuple(Descriptor->Purphandle, result, node->ary);
	
	RESCPY(node, result);

	return node->result;
} /* tupleptr_t NextSORT() */

/* END.*/